Turbine.Gameplay.Attributes.WardenGambit.Javelin = 4;
Turbine.Gameplay.Attributes.MinstrelStance.Harmony = 2;
Turbine.Gameplay.ReadyState.Unknown = 0;
_G.trim = function(s)
	return string.gsub(s, "^%s*(.-)%s*$", "%1");
end

_G.snarfargs = function(arguments)
	local args = { };

	for v in string.gmatch(arguments, "%S+") do
		table.insert(args, v);
	end
	return args;
end

_G.snarfversion = function(arguments)
	local version = { };

	for v in string.gmatch(arguments, "%d+") do
		table.insert(version, tonumber(v));
	end
	return version;
end

_G.serialize = function(t)
	if type(t) == "number" then
		return string.gsub(tostring(t), ",", ".");
	elseif type(t) == "string" then
		return string.gsub(string.format("%q", t), "([\128-\255])", function (c) return string.format("\\%03d", string.byte(c)); end);
	elseif type(t) == "table" then
		local s = nil;

		for k, v in pairs(t) do
			if s == nil then
				s = "[" .. _G.serialize(k) .. "] = " .. _G.serialize(v);
			else
				s = s .. ", [" .. _G.serialize(k) .. "] = " .. _G.serialize(v);
			end
		end
		if s == nil then
			return "{ }";
		else
			return "{ " .. s .. " }";
		end
	else
		return tostring(t);
	end
end

-- Note: Does not handle self referencing tables
_G.tabledeepcopy = function(t)
	local r = { };

	for k, v in pairs(t) do
		if type(v) == "table" then
			r[k] = tabledeepcopy(v);
		else
			r[k] = v;
		end
	end

	return r;
end

_G.sign = function(x)
	if x > 0 then
		return 1;
	elseif x < 0 then
		return -1;
	end
	return 0;
end

local fonts = { };

for k, v in pairs(Turbine.UI.Lotro.Font) do
	local x, _, f, s = string.find(k, "^(%D*)(%d*)$");

	if x ~= nil then
		if fonts[f] == nil then
			fonts[f] = { };
		end
		table.insert(fonts[f], tonumber(s));
	end
end
for k, v in pairs(fonts) do
	table.sort(v, function(a, b) return a > b; end);
end

_G.fontsize = function(f, s)
	if fonts[f] ~= nil then
		for _, v in ipairs(fonts[f]) do
			if v <= s then
				return Turbine.UI.Lotro.Font[f .. tostring(v)];
			end
		end
		return Turbine.UI.Lotro.Font[f .. tostring(fonts[f][#fonts[f]])];
	end

	return nil;
end