import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "moebius92.ColorBar";
import "moebius92.Handlers";
import "moebius92.Misc";

import "moebius92.PartyFrame.LayoutInit";

import "moebius92.PartyFrame.Layout.Line";
import "moebius92.PartyFrame.Layout.Grid";

import "moebius92.PartyFrame.StringResources";

import "moebius92.PartyFrame.PartyFrameWindow";
import "moebius92.PartyFrame.PartyFrameCommand";

plugin.window = PartyFrameWindow(plugin:GetVersion());
plugin.command = PartyFrameCommand(plugin);
Turbine.Shell.AddCommand(string.lower(plugin:GetName()), plugin.command);
Turbine.Shell.AddCommand(S.CommandCommandS, plugin.command);

function plugin:Load(args)
	local state = Turbine.PluginData.Load(Turbine.DataScope.Account, "PartyFrame");
	if type(state) == "string" then
		state = loadstring("return " .. state .. ";")();
	end
	if state ~= nil and (Turbine.Engine.GetLocalTime() - state.time) < 15 then
		self.window.fellowship = state.fellowship;
		self.window.grid = state.grid;
		self.window:PartyMemberChanged();
	end
end

function plugin:Unload(args)
	local state = { };

	Turbine.UI.Lotro.LotroUI.SetEnabled(Turbine.UI.Lotro.LotroUIElement.Party, true);
	state.time = Turbine.Engine.GetLocalTime();
	state.fellowship = self.window.fellowship;
	state.grid = self.window.grid;
	Turbine.PluginData.Save(Turbine.DataScope.Account, "PartyFrame", serialize(state));
end

function plugin:GetOptionsPanel()
	return self.window.options;
end